package com.njcn.device.pq.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.device.biz.utils.DeviceEnumUtil;
import com.njcn.device.pq.api.NodeClient;
import com.njcn.device.pq.api.PqsTerminalLogsClient;
import com.njcn.device.pq.pojo.po.Node;
import com.njcn.device.pq.pojo.po.PqsTerminalLogs;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author zbj
 * @version 1.0.0
 * @date 2023年04月13日 13:34
 */
@Slf4j
@Component
public class NodeClientFallbackFactory implements FallbackFactory<NodeClient> {
    @Override
    public NodeClient create(Throwable throwable) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if (throwable.getCause() instanceof BusinessException) {
            BusinessException businessException = (BusinessException) throwable.getCause();
            exceptionEnum = DeviceEnumUtil.getExceptionEnum(businessException.getResult());
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new NodeClient()
        {

            @Override
            public HttpResult<List<Node>> nodeAllList() {
                log.error("{}异常，降级处理，异常为：{}", "获取全部前置机", throwable.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<Node> getNodeById(String id) {
                log.error("{}异常，降级处理，异常为：{}", "根据id获取前置机", throwable.toString());
                throw new BusinessException(finalExceptionEnum);
            }
        };


    }
}
